<template>
  <ModalWindow id="confirm-prompt" :title="title" :buttons="buttons" @button="onButton" :show="showModal">
    <div v-html="text" />
  </ModalWindow>
</template>

<script>
import { ref } from 'vue'
import { useEventBus } from '../plugins/event-bus-plugin.js'
import ModalWindow from './modal-window.vue'

export default {
  name: 'ConfirmPrompt',
  components: {
    ModalWindow,
  },
  setup() {
    const eventBus = useEventBus()
    let resolve = () => {}
    let reject = () => {}

    const showModal = ref(false)
    const text = ref('')
    const title = ref('')
    const buttons = ref([
      {
        id: 'ok',
        text: 'Ok',
        class: 'btn btn-primary me-auto',
        iconClass: 'bi bi-check-lg',
        disabled: false,
        visible: true,
      },
      {
        id: 'cancel',
        text: 'Cancel',
        class: 'btn btn-primary',
        iconClass: 'bi bi-x-lg',
        disabled: false,
        visible: true,
      },
    ])

    const onButton = (buttonId) => {
      showModal.value = false
      if (buttonId === 'ok') {
        if (resolve) {
          resolve()
        }
      } else {
        if (reject) {
          reject()
        }
      }
    }

    eventBus.on('confirm-prompt-show', (options) => {
      text.value = options.text
      title.value = options.title
      resolve = options.resolve
      reject = options.reject
      showModal.value = true
    })

    return {
      showModal,
      text,
      title,
      buttons,

      onButton,
    }
  },
}
</script>
